<template>
  <div ref="form">
    <transition name="fade" mode="out-in">
      <div class="row card-pay" v-if="state === 0" :class="{blocked: displayTdsModal}">
        <div>
          <div class="white-block" ref="payBlock">
            <div class="section__header section__header-with-back">
              <div class="section__header-back"
                   @click="$pay.paymentType === 'credit_rating' ? $router.push({name: 'credit-rating', params:{page: 'filling-form'}}) : $emit('hideForm')">
                <SVGIcon xlink="next-arrow-20" viewBox="0 0 20 20" :rotate="180"/>
              </div>
              <h3 class="section__header-title">{{selectPay ? $pay.paymentType === 'credit_rating' ?  'СУММА ПЛАТЕЖА' : 'ОПЛАТА БАНКОВСКОЙ КАРТОЙ' : $route.meta.section !== 'pos' ? 'ВЫБЕРИТЕ КАРТУ ИЛИ ДОБАВЬТЕ НОВУЮ' : 'ВВЕДИТЕ ДАННЫЕ КАРТЫ'}}</h3>
            </div>
            <div :class="[selectPay ? 'padding' : '']">
              <sum-and-order
                      v-model="paymentSum"
                      :card="true"
                      ref="sum"
                      v-show="selectPay"/>

              <select-card v-show="!selectPay"
                           @cancelPay="selectPay = true"
                           @anyWayPay="$emit('hideForm')"
                           @success="success"
                           @back="back"
                           :sum="parseFloat(paymentSum)"
                           :additional_service="additional_service"/>
            </div>
          </div>

        </div>
      </div>
    </transition>

    <additional-services @hideForm="$emit('hideForm')"
                         @getSelectedParams="getSelectedParams"
                         @click="getGuid"
                         v-show="selectPay && component !== 'POS'"
                         :sum="paymentSum"
                         :blocker="blocker"
                         :showForm="true"
    ></additional-services>

    <tds-modal v-if="displayTdsModal && $config.tdsUseModal" @close="displayTdsModal = false"></tds-modal>
    <tds-iframe v-else-if="displayTdsModal" :data="tdsData"></tds-iframe>

    <pay-result v-if="state" :state="state" @close-message="resultMessageClosed"></pay-result>
  </div>
</template>

<script>
  import SumAndOrder from '@/components/Pay/SumAndOrder'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin';
  import tdsModal from '@/components/Modals/tds.vue'
  import tdsIframe from '@/components/Modals/tdsIframe.vue'
  import payResult from '@/components/Modals/PayResult.vue';
  import AdditionalServices from '@/components/Chunks/AdditionalServices';
  import SelectCard from '@/components/Pay/PaymentMethods/SelectCard'
  import SVGIcon from "../../SVGIcon/index";

  let stateMessage = false;

  export default {
    name: 'cardForm',
    components: {
      SVGIcon,
      tdsModal,
      SumAndOrder,
      payResult,
      tdsIframe,
      AdditionalServices,
      SelectCard,
    },
    mixins: [GetValidateClass],
    props: {
      component: {
        type: String,
        required: false,
        default: '',
      }
    },
    data() {
      return {
        displayTdsModal: false,
        state: 0,
        paymentSumValue: 0,
        tdsData: {},
        selectPay: true,
        additional_service: [],
        blocker: false
      }
    },
    computed: {
      paymentSum: {
        get() {
          return this.paymentSumValue;
        },

        set(v) {
          this.paymentSumValue = v;
          this.$emit('input', v);
        }
      }
    },
      watch: {
          selectPay(state) {
              this.$nextTick(() => {
                  this.$helpers.scroll(this.$refs.payBlock);
              });
          }
      },
    created() {
        console.log('CardForm::created');
      stateMessage = false;
      this.paymentSumValue = this.$attrs['v-model'];
      this.$on('success', (data) => {
          this.success(data);
      });
      this.$events.$on('payment.card.token.success', (data) => {
          this.success(data);
      });

      switch(this.component) {
        case 'POS':
          this.initPos();
          break;
      }
    },
      beforeDestroy () {
        console.groupCollapsed('CardForm::beforeDestroy');
        console.trace();
        console.groupEnd();
        this.$events.$off('payment.card.token.success');
      },

    methods: {
      initPos () {
        // для посов мы сразу показываем данные.
        this.selectPay = false;
      },
      getSelectedParams (array_service) {
          console.log('CardForm::getSelectedParams')
        this.additional_service = array_service
      },
      getGuid () {
          console.log('CardForm::getGuid');
        if (this.additional_service.length) {
          let service = this.additional_service
          let services = service.map((acc)=> {
            return acc.id
          });
          this.$store.commit('PAYMENT_SET_ADDITIONAL_SERVICES', services);

        }
          this.selectPay = false;
      },
      resultMessageClosed () {
        this.state = 0 ;
        this.displayTdsModal = false;
      },
      success() {
          console.trace();
        this.state = 1;
        // this.$toastr.success('Оплата прошла успешно. Деньги поступят на счет в течении 10 минут.', 'Успешно');
        this.$nextTick(() => {
            console.log('success payment');
          this.$helpers.scroll(this.$root.$el);
          this.$modal.show('payResult');
          this.$payment.process = false;

        });

        this.$store.commit('PAYMENT_TRUNCATE_ADDITIONAL_SERVICES');
        this.$emit('pay-success');
      },
      error() {
        this.state = 2;
        // this.$toastr.error('Ошибка оплаты', 'Ошибка');
        this.$nextTick(() => {
          this.$helpers.scroll(this.$root.$el);
          this.$modal.show('payResult');
          this.$payment.process = false;
        })

        this.$emit('pay-error')
      },

        back() {
          console.log('CardForm::back');
          this.$emit('return-to-loan');
        }
    }
  }
</script>

<style scoped>

  .noborder {
    border: none !important;
  }

  input[type=number]::-webkit-inner-spin-button,
  input[type=number]::-webkit-outer-spin-button {
    -webkit-appearance: none;
    margin: 0;
  }

  .blocked {
    opacity: 0.6;
    pointer-events: none;
  }

  img.card-logo {
    position: absolute;
    margin-top: 3px;
    top: 43px;
    right: 5px;
  }
</style>

